'**** ADDINCONFIG - HEADER - BEGIN ****
    '>>>> Dieser Code wird automatisch generiert <<<<
    Set m_ViewAkt_Installer = New clsViewAkt_Installer
'**** ADDINCONFIG - HEADER - END ****





'**** ADDINCONFIG - CLASS - BEGIN ****
'>>>> Dieser Code wird automatisch generiert <<<<
Class clsViewAkt_Installer
    Dim dbData
    Dim paramData
    Dim AddInName 
'**** ADDINCONFIG - CLASS - END ****

    Dim ATTRIBUTEREADONLY 
	Dim m_oFS 'As Scripting.FileSystemObject
	Dim m_oFF 'As FlowFact.Application
	Dim m_oDev 'As FFDeveloper.Application

	Sub FF_Init
        Set m_oFF = GetObject("", "FlowFact.Application")
		Set m_oDev = GetObject("", "FFDeveloper.Application")
        Set m_oFS = CreateObject("Scripting.FileSystemObject")
		
		m_oDev.FlowFact_SetApplication m_oFF
		
        ATTRIBUTEREADONLY = 1
	End Sub
    
    Sub FF_Terminate
        Set m_oFF = Nothing
        Set m_oFS = Nothing
		Set m_oDev = Nothing
	End Sub
    '********************************************
    '** Callback_Install
    '********************************************
    Sub Callback_Install
	    Const DOWNLOADPFAD = "\system\AddInDownload\Solution\ViewAkt\_Data" 
	    Dim strErrorMsg 'As String
	    Dim strPfadname 'As String
	    Dim strFolderSource 'As String
	    Dim strFolderDest 'As String
        
        FF_Init
        
	    strErrorMsg = ""
        '****************************************
        '** Dateien-Sichern
        '****************************************
	    LoadinZipFile
	                                             
        '****************************************
        '** Dateien-Kopieren
        '****************************************	                                             
	    strPfadname = m_oFF.Folder
	    strFolderSource = strPfadname & DOWNLOADPFAD
	    strFolderDest = strPfadname
	
	    'If CreateFolder(strFolderDest) = False Then
	    '    strErrorMsg = "Der Ordner '" & strFolderDest & "' konnte nicht angelegt werden."
	    'Else
        If CheckFolderAttribute(strFolderDest) = True Then
	        strErrorMsg = "Der Ordner '" & strFolderDest & "' ist schreibgeschtzt. Bitte voher Schreibschutz entfernen."
	    Else
	        strErrorMsg = CopyFolder(strFolderSource, strFolderDest)
	    End If
	
	    If strErrorMsg = "" Then
	        'MsgBox "Der Ordner wurde erfolgreich kopiert!", vbInformation + vbOKOnly, "FlowFact"	        
	        oInstaller.InstallAll
	    Else
	        'strErrorMsg = "Fehler: " & strErrorMsg & vbCrLf & "Installation wird abgebrochen."
	        err.Raise 2000, "AddIn-Install", strErrorMsg
	        'MsgBox strErrorMsg, vbInformation + vbOKOnly, "FlowFact"
	    End If
		
		'Zur automatischen Aktualisierung auf den Clients (FF-4335) muss noch ein Flag in der DB gesetzt werden.
		'Als Version ist hier nicht die echte Version gemeint, sondern das Letzte nderungsdatum
		'Aus den Erfahrungen bei WSE gibt es manchmal Probleme beim lesen der Dateiversion
		
        FF_Terminate
	    
        'msgbox "Das Kopieren der neuen MSOffice AddIns ist beendet." & vbcrlf & vbcrlf & "Als nchster Schritt mssen diese fr jeden Benutzer auf seinem Arbeitsplatz aktualisiert werden." & vbcrlf & "Hierzu muss von jedem Benutzer in der Hilfe-Menleiste 'Microsoft Office AddIns installieren' aufgerufen werden.",vbInformation,"FlowFact Office AddIn"
        
	End Sub

	'********************************************
    '** LoadinZipFile
    '********************************************	
	Sub LoadinZipFile
	    Dim strZipFileName 'As String
	    Dim strFilesPath 'As String
	    Dim strBaseFolder 'As String
	    Dim strFolderDestPath 'As String
	    Dim strFolderSourcePath 'As String
	    Dim oFile 'As File
	    
	    'Name des Base Ordners
	    strBaseFolder = m_oFF.Folder
	    
	    'Pfad des zu packenden Ordners
	    strFolderSourcePath = m_oFF.Folder
	    
	    'Pfad der zu packenden Dateien
	    strFilesPath = strFolderSourcePath & "\FlowFact_ww8.dot" & " " & strFolderSourcePath & "\FlowFact.xla"
	    
	    ' Zielpfad fr die Zipfiles
	    strFolderDestPath = m_oFF.Folder & "\Dat\"
	    
	    ' Name der Zipfile
	    strZipFileName = strFolderDestPath & "Office_Backup_" & Replace(paramData("AddIn.Version"), ".", "_") & ".zip"
	    'Format(Now, "dd.mm.yyyy.hh-nn-ss")
	    
	    If m_oFS.FileExists(strZipFileName) = False Then	        
            DoZip strZipFileName, strFilesPath, strBaseFolder
        End If
 	End Sub
	'********************************************
	'** Function DoZip
	'********************************************
	Function DoZip(ByVal strZipFileName, ByVal strFilesPath, ByVal strBaseFolder)
	    Dim oZip 'As clacastdc10.cZip
	    
	    Set oZip = CreateObject("clacastdc10.cZIP")
	                                   
	    '** blnRecurse=False; weil backupordner vom setup nicht gesichert werden mssen
	    oZip.AddFile CStr(strZipFileName), CStr(strFilesPath), CStr(strBaseFolder), False
	    
	    Set oZip = Nothing
	End Function
	
	'********************************************
	'** Function CopyFolder
	'********************************************
	Function CopyFolder(ByVal strFolderSource, ByVal strFolderDest) 'As String
	    Dim strErrorMsg 'As String
	    Dim oFile 'As File
	    Dim oFolder 'As Folder
	    Dim oSubFolder 'As Folder
	    Dim strFileName 'As String
	    Dim strSubFolderDest 'As String
	    
	    strErrorMsg = ""
	    
	    If m_oFS.FolderExists(strFolderSource) = False Then
	        CopyFolder = "Quellpfad '" & strFolderSource & "' nicht gefunden"
	        Exit Function
	    End If
	    
	    If CreateFolder(strFolderDest) = False Then
	        CopyFolder = "Der Ordner '" & strFolderDest & "' konnte nicht angelegt werden."
	        Exit Function
	    End If
	     
	    Set oFolder = m_oFS.GetFolder(strFolderSource)
	
	    '** Dateien kopieren
	    For Each oFile In oFolder.Files
	        
	        strFileName = oFile.Name
	        On Error Resume Next
	        m_oFS.CopyFile strFolderSource & "\" & strFileName, strFolderDest & "\" & strFileName
	
	        If Err <> 0 Then
	            strErrorMsg = "Die Datei '" & strFileName & "' konnte nicht kopiert werden. Eventuell Schreibschutz entfernen."
	            Exit For
	        End If
	        
	        If CheckFileAttribute(oFile) = False Then
	            DeleteFileAttribute strFolderDest & "\" & strFileName, ATTRIBUTEREADONLY
	        End If
	    Next
	
	    '** Unterverzeichnisse kopieren
	    If strErrorMsg = "" Then
	        For Each oSubFolder In oFolder.SubFolders
	            strErrorMsg = CopyFolder(strFolderSource & "\" & oSubFolder.Name, strFolderDest & "\" & oSubFolder.Name)
	            If strErrorMsg <> "" Then
	                Exit For
	            End If
	        Next
	    End If
	    
	    CopyFolder = strErrorMsg
	End Function
	
	'********************************************
	'** Function CreateFolder
	'********************************************
	Function CreateFolder(ByVal strFolder) 'As Boolean
	    '** Einen neuen Ordner anlegen, wenn nicht vorhanden
	    CreateFolder = True
	    
	    If m_oFS.FolderExists(strFolder) = True Then
	        Exit Function
	    End If
	    
	    On Error Resume Next
	    m_oFS.CreateFolder strFolder
	    If Err <> 0 Then
	        CreateFolder = False
	    End If
	End Function
	
	'********************************************
	'** Function CheckFileAttribute
	'********************************************
	Function CheckFileAttribute(ByVal oFile) 'As Boolean
	    If (oFile.Attributes And ATTRIBUTEREADONLY) > 0 Then
	        CheckFileAttribute = False
	    Else
	        CheckFileAttribute = True
	    End If
	End Function
	
	'********************************************
	'** Function DetleteFileAttribute
	'********************************************
	Function DeleteFileAttribute(ByVal strFileName, ByVal lngAttribute) 'As Boolean
	    Dim oFile 'As Object
	    
	    DeleteFileAttribute = False
	    
	    On Error Resume Next
	    Set oFile = m_oFS.GetFile(strFileName)
	    
	    oFile.Attributes = oFile.Attributes And (Not lngAttribute)
	    If Err <> 0 Then
	        DeleteFileAttribute = True
	    End If
	End Function
	
	'********************************************
	'** Function CheckFolderAttribute
	'********************************************
	Function CheckFolderAttribute(ByVal strFolder) 'As Boolean
	    Dim oFolder 'As Folder
	    
	    Set oFolder = m_oFS.GetFolder(strFolder)
	 
	    If oFolder.Attributes And ATTRIBUTEREADONLY > 0 Then
	        CheckFolderAttribute = False
	    Else
	        CheckFolderAttribute = True
	    End If
	    
	End Function
	

    '********************************************
    '** Callback_Uninstall
    '********************************************
    Sub Callback_Uninstall
        FF_Init    	
        If m_oFS.FileExists(m_oFF.Folder & "\system\OfficeTester.exe") Then
            m_oFS.DeleteFile m_oFF.Folder & "\system\OfficeTester.exe" 
        End If    	        
    	FF_Terminate
    End Sub

'**** ADDINCONFIG - FOOTER - BEGIN ****
    '>>>> Dieser Code wird automatisch generiert <<<<
    Sub Callback_AddInInternalInit
        AddInName = "ViewAkt"

        Set paramData = CreateObject("Scripting.Dictionary")
        paramData.CompareMode = 1

        paramData("AddIn.Name") = AddInName
        paramData("AddIn.FileName") = "ViewAkt"
        paramData("AddIn.Version") = "1.0.1"
        paramData("AddIn.Author") = "Volkmar Grimm"
        paramData("AddIn.MinFFBuild") = "492"
        paramData("AddIn.Description") = "Das ViewAktAddIn stellt das Notizfeld einer Aktivtt direkt dar\n\n====================================================\n The ViewAktAddIn shows the Notizfield directly"
        paramData("AddIn.History") = "Version: 1.0.1\nAuthor: ffvolkmargrimm\nDate: 26.03.2018 10:19:32\nDescription: Net Version\n****************************************\nVersion: 1.0.0\nAuthor: ffvolkmargrimm\nDate: 10.01.2018 16:00:33\nDescription: Erstellen Majorversion\n****************************************"

        Set dbData = CreateObject("Scripting.Dictionary")
        dbData.CompareMode = 1


        '** Internes Installerobject 
        oInstaller.Init paramData, dbData 
    End Sub

End Class
'**** ADDINCONFIG - FOOTER - END ****
